Coin: SoTexture3 Class Reference

| Coin3D is Free Software, published under the BSD 3-clause license. | https://coin3d.github.io https://www.kongsberg.com/en/kogt/

SoTexture3 Class Reference
Node Classes

The SoTexture3 class is used to map a 3D texture onto geometry. More...

`#include <Inventor/nodes/SoTexture3.h>`

Inheritance diagram for SoTexture3:

## Public Types
enum | Model { MODULATE = SoMultiTextureImageElement::MODULATE , DECAL = SoMultiTextureImageElement::DECAL , BLEND = SoMultiTextureImageElement::BLEND }
enum | Wrap { REPEAT = SoMultiTextureImageElement::REPEAT , CLAMP = SoMultiTextureImageElement::CLAMP }
Public Types inherited from SoNode
enum | NodeType { INVENTOR = 0x0000 , VRML1 = 0x0001 , VRML2 = 0x0002 , INVENTOR_1 = 0x0004 , INVENTOR_2_0 = 0x0008 , INVENTOR_2_1 = 0x0010 , INVENTOR_2_5 = 0x0020 , INVENTOR_2_6 = 0x0040 , COIN_1_0 = 0x0080 , COIN_2_0 = 0x0100 , EXTENSION = 0x0200 , COIN_2_2 = 0x0400 , COIN_2_3 = 0x0800 , COIN_2_4 = 0x1000 , INVENTOR_5_0 = 0x2000 , COIN_2_5 = 0x4000 , COIN_3_0 = 0x8000 , INVENTOR_6_0 = 0x10000 , COIN_4_0 = 0x20000 }

## Public Member Functions
virtual SoType | getTypeId (void) const
| SoTexture3 (void)
virtual void | doAction (SoAction *action)
virtual void | GLRender (SoGLRenderAction *action)
virtual void | callback (SoCallbackAction *action)
Public Member Functions inherited from SoNode
void | setOverride (const SbBool state)
SbBool | isOverride (void) const
void | setNodeType (const NodeType type)
NodeType | getNodeType (void) const
virtual SoNode * | copy (SbBool copyconnections=FALSE) const
virtual SbBool | affectsState (void) const
virtual void | GLRenderBelowPath (SoGLRenderAction *action)
virtual void | GLRenderInPath (SoGLRenderAction *action)
virtual void | GLRenderOffPath (SoGLRenderAction *action)
virtual void | getBoundingBox (SoGetBoundingBoxAction *action)
virtual void | getMatrix (SoGetMatrixAction *action)
virtual void | handleEvent (SoHandleEventAction *action)
virtual void | pick (SoPickAction *action)
virtual void | rayPick (SoRayPickAction *action)
virtual void | search (SoSearchAction *action)
virtual void | write (SoWriteAction *action)
virtual void | audioRender (SoAudioRenderAction *action)
virtual void | getPrimitiveCount (SoGetPrimitiveCountAction *action)
virtual void | grabEventsSetup (void)
virtual void | grabEventsCleanup (void)
virtual void | startNotify (void)
SbUniqueId | getNodeId (void) const
virtual SoChildList * | getChildren (void) const
virtual void | writeInstance (SoOutput *out)
virtual SoNode * | addToCopyDict (void) const
virtual void | copyContents (const SoFieldContainer *from, SbBool copyconnections)
virtual SoFieldContainer * | copyThroughConnection (void) const
Public Member Functions inherited from SoFieldContainer
void | setToDefaults (void)
SbBool | hasDefaultValues (void) const
SbBool | fieldsAreEqual (const SoFieldContainer *container) const
void | copyFieldValues (const SoFieldContainer *container, SbBool copyconnections=FALSE)
SbBool | set (const char *const fielddata)
void | get (SbString &fielddata)
virtual int | getFields (SoFieldList &l) const
virtual int | getAllFields (SoFieldList &l) const
virtual SoField * | getField (const SbName &name) const
virtual SoField * | getEventIn (const SbName &name) const
virtual SoField * | getEventOut (const SbName &name) const
SbBool | getFieldName (const SoField *const field, SbName &name) const
SbBool | enableNotify (const SbBool flag)
SbBool | isNotifyEnabled (void) const
SbBool | set (const char *fielddata, SoInput *input)
void | get (SbString &fielddata, SoOutput *out)
virtual SbBool | validateNewFieldValue (SoField *field, void *newval)
virtual void | addWriteReference (SoOutput *out, SbBool isfromfield=FALSE)
SbBool | getIsBuiltIn (void) const
virtual void | getFieldsMemorySize (size_t &managed, size_t &unmanaged) const
void | setUserData (void *userdata) const
void * | getUserData (void) const
Public Member Functions inherited from SoBase
void | ref (void) const
void | unref (void) const
void | unrefNoDelete (void) const
int32_t | getRefCount (void) const
void | touch (void)
SbBool | isOfType (SoType type) const
| Returns `TRUE` if the type of this object is either of the same type or inherited from type.
virtual SbName | getName (void) const
virtual void | setName (const SbName &newname)
void | addAuditor (void *const auditor, const SoNotRec::Type type)
void | removeAuditor (void *const auditor, const SoNotRec::Type type)
const SoAuditorList & | getAuditors (void) const
SbBool | shouldWrite (void)
void | assertAlive (void) const

## Static Public Member Functions
static SoType | getClassTypeId (void)
static void | initClass (void)
| Sets up initialization for data common to all instances of this class, like submitting necessary information to the Coin type system.
Static Public Member Functions inherited from SoTexture
static SoType | getClassTypeId (void)
static void | initClass (void)
| Sets up initialization for data common to all instances of this class, like submitting necessary information to the Coin type system.
static void | cleanupClass (void)
Static Public Member Functions inherited from SoNode
static uint32_t | getCompatibilityTypes (const SoType &nodetype)
static SoType | getClassTypeId (void)
static SoNode * | getByName (const SbName &name)
static int | getByName (const SbName &name, SoNodeList &l)
static void | initClass (void)
| Sets up initialization for data common to all instances of this class, like submitting necessary information to the Coin type system.
static void | initClasses (void)
static SbUniqueId | getNextNodeId (void)
static int | getActionMethodIndex (const SoType type)
static void | getBoundingBoxS (SoAction *action, SoNode *node)
static void | GLRenderS (SoAction *action, SoNode *node)
static void | callbackS (SoAction *action, SoNode *node)
static void | getMatrixS (SoAction *action, SoNode *node)
static void | handleEventS (SoAction *action, SoNode *node)
static void | pickS (SoAction *action, SoNode *node)
static void | rayPickS (SoAction *action, SoNode *node)
static void | searchS (SoAction *action, SoNode *node)
static void | writeS (SoAction *action, SoNode *node)
static void | audioRenderS (SoAction *action, SoNode *node)
static void | getPrimitiveCountS (SoAction *action, SoNode *node)
Static Public Member Functions inherited from SoFieldContainer
static void | initClass (void)
| Sets up initialization for data common to all instances of this class, like submitting necessary information to the Coin type system.
static SoType | getClassTypeId (void)
| This static method returns the SoType object associated with objects of this class.
static void | cleanupClass (void)
static void | initCopyDict (void)
static void | addCopy (const SoFieldContainer *orig, const SoFieldContainer *copy)
static SoFieldContainer * | checkCopy (const SoFieldContainer *orig)
static SoFieldContainer * | findCopy (const SoFieldContainer *orig, const SbBool copyconnections)
static void | copyDone (void)
Static Public Member Functions inherited from SoBase
static void | initClass (void)
| Sets up initialization for data common to all instances of this class, like submitting necessary information to the Coin type system.
static SoType | getClassTypeId (void)
| This static method returns the SoType object associated with objects of this class.
static void | addName (SoBase *const base, const char *const name)
static void | removeName (SoBase *const base, const char *const name)
static void | incrementCurrentWriteCounter (void)
static void | decrementCurrentWriteCounter (void)
static SoBase * | getNamedBase (const SbName &name, SoType type)
static int | getNamedBases (const SbName &name, SoBaseList &baselist, SoType type)
static SbBool | read (SoInput *input, SoBase *&base, SoType expectedtype)
static void | setInstancePrefix (const SbString &c)
static void | setTraceRefs (SbBool trace)
static SbBool | getTraceRefs (void)
static SbBool | connectRoute (SoInput *input, const SbName &fromnodename, const SbName &fromfieldname, const SbName &tonodename, const SbName &tofieldname)
static SbBool | readRoute (SoInput *input)

## Public Attributes
SoMFString | filenames
SoSFImage3 | images
SoSFEnum | wrapR
SoSFEnum | wrapS
SoSFEnum | wrapT
SoSFEnum | model
SoSFColor | blendColor
SoSFBool | enableCompressedTexture

## Protected Member Functions
virtual const SoFieldData * | getFieldData (void) const
virtual | ~SoTexture3 ()
virtual SbBool | readInstance (SoInput *in, unsigned short flags)
virtual void | notify (SoNotList *list)
int | getReadStatus (void)
void | setReadStatus (int s)
Protected Member Functions inherited from SoNode
| SoNode (void)
virtual | ~SoNode ()
Protected Member Functions inherited from SoFieldContainer
| SoFieldContainer (void)
virtual | ~SoFieldContainer ()
Protected Member Functions inherited from SoBase
| SoBase (void)
virtual | ~SoBase ()
virtual void | destroy (void)
SbBool | hasMultipleWriteRefs (void) const
SbBool | writeHeader (SoOutput *out, SbBool isgroup, SbBool isengine) const
void | writeFooter (SoOutput *out) const
virtual const char * | getFileFormatName (void) const
virtual SoNotRec | createNotRec (void)

## Static Protected Member Functions
static const SoFieldData ** | getFieldDataPtr (void)
Static Protected Member Functions inherited from SoTexture
static const SoFieldData ** | getFieldDataPtr (void)
Static Protected Member Functions inherited from SoNode
static const SoFieldData ** | getFieldDataPtr (void)
static void | setNextActionMethodIndex (int index)
static int | getNextActionMethodIndex (void)
static void | incNextActionMethodIndex (void)
static void | setCompatibilityTypes (const SoType &nodetype, const uint32_t bitmask)
Static Protected Member Functions inherited from SoBase
static uint32_t | getCurrentWriteCounter (void)
static void | staticDataLock (void)
static void | staticDataUnlock (void)

## Additional Inherited Members
Protected Types inherited from SoBase
enum | BaseFlags { IS_ENGINE = 0x01 , IS_GROUP = 0x02 }
Protected Attributes inherited from SoNode
SbUniqueId | uniqueId
Protected Attributes inherited from SoFieldContainer
SbBool | isBuiltIn
Static Protected Attributes inherited from SoNode
static SbUniqueId | nextUniqueId = 1
static int | nextActionMethodIndex = 0

## Detailed Description

The SoTexture3 class is used to map a 3D texture onto geometry.

Shape nodes within the scope of SoTexture3 nodes in the scene graph (i.e. below the same SoSeparator and to the right hand side of the SoTexture3) will have the texture applied according to each shape type's individual characteristics. See the documentation of the various shape types (SoFaceSet, SoCube, SoSphere, etc.) for information about the specifics of how the textures will be applied. An SoTexture3 node will override any previous encountered SoTexture2 nodes and vice versa. Mixing of SoTexture3 and SoTextureCoordinate2 (or the other way around) is legal, but the third texture coordinate component will be ignored (set to 0.0).

Rendering of an Example Texture3

Be aware that this class is an extension for Coin, and it is not available in the original SGI Open Inventor v2.1 API.
FILE FORMAT/DEFAULTS:

Texture3 {
filenames ""
images 0 0 0 0
wrapR REPEAT
wrapS REPEAT
wrapT REPEAT
model MODULATE
blendColor 0 0 0
enableCompressedTexture FALSE
}
SoTexture3::model
SoSFEnum model
Definition SoTexture3.h:73
SoTexture3::images
SoSFImage3 images
Definition SoTexture3.h:69
SoTexture3::wrapT
SoSFEnum wrapT
Definition SoTexture3.h:72
SoTexture3::blendColor
SoSFColor blendColor
Definition SoTexture3.h:74
SoTexture3::REPEAT
@ REPEAT
Definition SoTexture3.h:64
SoTexture3::wrapS
SoSFEnum wrapS
Definition SoTexture3.h:71
SoTexture3::MODULATE
@ MODULATE
Definition SoTexture3.h:58
SoTexture3::filenames
SoMFString filenames
Definition SoTexture3.h:68
SoTexture3::enableCompressedTexture
SoSFBool enableCompressedTexture
Definition SoTexture3.h:75
SoTexture3::wrapR
SoSFEnum wrapR
Definition SoTexture3.h:70

Since
  Coin 2.0
  TGS Inventor 2.6

## Member Enumeration Documentation

## ◆ Model

enum SoTexture3::Model

Texture mapping model.

Enumerator
MODULATE | Texture image is modulated with polygon.
DECAL | Texture image overwrites polygon color.
BLEND | Blend image using blendColor.

## ◆ Wrap

enum SoTexture3::Wrap

Enum used to specify wrapping strategy.

Enumerator
REPEAT | Repeat texture when coordinate is not between 0 and 1.
CLAMP | Clamp coordinate between 0 and 1.

## Constructor & Destructor Documentation

## ◆ SoTexture3()

SoTexture3::SoTexture3 | ( | void |  | ) |

Constructor.

## ◆ ~SoTexture3()

SoTexture3::~SoTexture3 | ( |  | ) |
| protectedvirtual

Destructor.

## Member Function Documentation

## ◆ getClassTypeId()

SoType SoTexture3::getClassTypeId | ( | void |  | ) |
| static

This static method returns the SoType object associated with objects of this class.

## ◆ getTypeId()

SoType SoTexture3::getTypeId | ( | void |  | ) | const
| virtual

Returns the type identification of an object derived from a class inheriting SoBase. This is used for runtime type checking and "downward" casting.

Reimplemented from SoTexture.

## ◆ getFieldDataPtr()

const SoFieldData ** SoTexture3::getFieldDataPtr | ( | void |  | ) |
| staticprotected

This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.
Returns the SoFieldData class which holds information about fields in this node.

## ◆ getFieldData()

const SoFieldData * SoTexture3::getFieldData | ( | void |  | ) | const
| protectedvirtual

Returns a pointer to the class-wide field data storage object for this instance. If no fields are present, returns `NULL`.

Reimplemented from SoTexture.

## ◆ doAction()

void SoTexture3::doAction | ( | SoAction * | action | ) |
| virtual

This function performs the typical operation of a node for any action.

Reimplemented from SoTexture.

## ◆ GLRender()

void SoTexture3::GLRender | ( | SoGLRenderAction * | action | ) |
| virtual

Action method for the SoGLRenderAction.

This is called during rendering traversals. Nodes influencing the rendering state in any way or want to throw geometry primitives at OpenGL override this method.

Reimplemented from SoTexture.

## ◆ callback()

void SoTexture3::callback | ( | SoCallbackAction * | action | ) |
| virtual

Action method for SoCallbackAction.

Simply updates the state according to how the node behaves for the render action, so the application programmer can use the SoCallbackAction for extracting information about the scene graph.

Reimplemented from SoTexture.

## ◆ readInstance()

SbBool SoTexture3::readInstance | ( | SoInput * | in,
|  | unsigned short | flags )
| protectedvirtual

This method is mainly intended for internal use during file import operations.

It reads a definition of an instance from the input stream in. The input stream state points to the start of a serialized / persistent representation of an instance of this class type.

`TRUE` or `FALSE` is returned, depending on if the instantiation and configuration of the new object of this class type went OK or not. The import process should be robust and handle corrupted input streams by returning `FALSE`.

flags is used internally during binary import when reading user extension nodes, group nodes or engines.

Reimplemented from SoNode.

## ◆ notify()

void SoTexture3::notify | ( | SoNotList * | l | ) |
| protectedvirtual

Notifies all auditors for this instance when changes are made.

Reimplemented from SoNode.

## ◆ getReadStatus()

int SoTexture3::getReadStatus | ( | void |  | ) |
| protected

Returns read status. 1 for success, 0 for failure.

## ◆ setReadStatus()

void SoTexture3::setReadStatus | ( | int | s | ) |
| protected

Sets read status.

See also
  getReadStatus()

## Member Data Documentation

## ◆ filenames

SoMFString SoTexture3::filenames

Texture filename(s). Specify either this or use SoTexture3::images, not both. The depth of the volume is specified by the number of filenames specified. All images must have the same dimensions and number of components. NB! A field sensor is attached to this field internally and reloads all images when this field changes. You must therefore be careful when setting this field and either use startEditing()/finishEditing() or set all values with one function call; setValues().

## ◆ images

SoSFImage3 SoTexture3::images

Inline image data.

## ◆ wrapR

SoSFEnum SoTexture3::wrapR

Wrapping strategy for the R coordinate (depth).

## ◆ wrapS

SoSFEnum SoTexture3::wrapS

Wrapping strategy for the S coordinate.

## ◆ wrapT

SoSFEnum SoTexture3::wrapT

Wrapping strategy for the T coordinate.

## ◆ model

SoSFEnum SoTexture3::model

Texture model.

## ◆ blendColor

SoSFColor SoTexture3::blendColor

Blend color. Used when SoTexture3::model is SoTexture3::BLEND.

## ◆ enableCompressedTexture

SoSFBool SoTexture3::enableCompressedTexture

Hint to Coin that compressed textures should be used if this is supported by the graphics hardware and OpenGL drivers. Using compressed textures usually reduces texture memory usage for a texture by 4-6 times.

Since
  Coin 2.4.2
  TGS Inventor 4.0

The documentation for this class was generated from the following files:

- SoTexture3.h
- SoTexture3.cpp